<template>
    <div v-if="isShow">
        <el-submenu v-if="isSubmenu"
                    :index="item.uuid"
                    :disabled="item.disabled"
                    :class="{'is-active': item.active}">
            <template slot="title">
                <i v-if="item.icon" :class="[item.icon]"></i>
                <span slot="title">{{ item.title }}</span>
            </template>
            <template v-for="deep in children">
                <item-menu :key="deep.uuid"
                           :item="deep"
                           :role="role"
                           :menu="menu"
                           :rTextColor="rTextColor"
                           :rActiveTextColor="rActiveTextColor"
                />
            </template>
        </el-submenu>

        <el-menu-item-group v-else-if="isMenuItemGroup">
            <template slot="title">{{ item.title }}</template>
            <template v-for="deep in children">
                <item-menu :key="deep.uuid"
                           :item="deep"
                           :role="role"
                           :menu="menu"
                           :rTextColor="rTextColor"
                           :rActiveTextColor="rActiveTextColor"
                />
            </template>
        </el-menu-item-group>

        <el-menu-item :index="item.uuid"
                      :disabled="item.disabled"
                      @click="to"
                      :class="{'is-active': item.active}"
                      :style="{color: item.active ? rActiveTextColor : rTextColor}"
                      v-else>
            <i v-if="item.icon" :class="[item.icon]"></i>
            <span slot="title">{{ item.title }}</span>
        </el-menu-item>
    </div>
</template>

<script>
    import { Submenu, MenuItemGroup, MenuItem } from 'element-ui'

    export default {

        name: 'item-menu',

        components: {
            'el-submenu': Submenu,
            'el-menu-item-group': MenuItemGroup,
            'el-menu-item': MenuItem,
        },

        props: {
            item: Object,
            role: Array,
            menu: Array,
            rTextColor: String,
            rActiveTextColor: String,
        },

        created () {
            let url = location.href
            if (this.item.link && url.toUpperCase().indexOf(this.item.link.toUpperCase()) !== -1) {
                this.patchActive()
            }
        },

        computed: {
            isSubmenu () {
                return this.item.type === 'element' && !!this.item.children
            },

            isMenuItemGroup () {
                return this.item.type === 'group'
            },

            children () {
                return this.item.children ? this.item.children.sort((a, b) => a.sort - b.sort) : []
            },

            isShow () {
                return this.item.visible
                    && (!this.item.roles.length
                        || this.item.roles.every(
                            role => this.role.map(one => one.toUpperCase()).indexOf(role.toUpperCase()) !== -1))
            },
        },

        methods: {

            to () {
                let url = new URL(this.item.link)
                if (this.$router && url.hostname === location.hostname) {
                    this.$router.push({path: url.pathname.replace(`${this.$router.options.base}/`, "/")})
                } else {
                    location.href = this.item.link
                }

                this.patchActive()
            },

            patchActive () {
                this.clearActive()
                this.setActive()
            },

            setActive (item = this.item) {
                if (item) {
                    item.active = true
                    this.setActive(item.parent || null)
                }
            },

            clearActive (items = this.menu) {
                if (items && items.length) {
                    items.forEach(item => {
                        item.active = false
                        this.clearActive(item.children || null)
                    })
                }
            },

        },

    }
</script>

<style lang="scss">

    .el-menu--collapse {
        & > div > li > div {
            span, .el-submenu__icon-arrow {
                display: none;
            }
        }
    }
</style>
